<?php

namespace Drupal\Tests\pdf_using_mpdf\Functional;

/**
 * Functional tests class.
 *
 * @package Drupal\Tests\pdf_using_mpdf\Functional
 */
class PdfUsingMpdfPcreBacktraceTest extends PdfUsingMpdfTestBase {

  /**
   * Modules to enable.
   *
   * @var array
   */
  protected static $modules = ['node', 'user', 'pdf_using_mpdf', 'pdf_using_mpdf_test'];

  /**
   * Dummy test function.
   */
  public function testPcreBacktrack(): void {
    $this->drupalLogin($this->adminUser);

    $this->drupalGet('admin/people/permissions');
    $this->submitForm(['authenticated[generate type_a pdf]' => TRUE], 'Save permissions');
    $this->assertSession()->pageTextContains('The changes have been saved.');

    $html = str_repeat('<p>Hello world!</p>', 10000);

    $node = $this->createNode([
      'type' => 'type_a',
      'title' => 'Test node title',
      'body' => [
        [
          'value' => $html,
        ],
      ],
    ]);

    $this->drupalGet('node/' . $node->id() . '/pdf');
    $this->assertSession()->statusCodeEquals(200);

  }

}
